//
//  PseudokoDocument.h
//  Pseudoko
//
//  Created by David Phillip Oster on 1/13/07.
//  Copyright David Phillip Oster 2007. 
//


#import <Cocoa/Cocoa.h>

 // for puzzle[][], below.
#define kIsLockedBit 0x10
#define kValueMask 0x0F

@interface PseudokoDocument : NSDocument {
 @private
  IBOutlet NSMatrix          *puzzleMatrix;
  NSArray                    *puzzleProxys; // STRONG used by - (void)solve;
  NSMutableArray             *moves;        // STRONG used by - (void)solve;
  BOOL                        creatorMode;
  BOOL                        isProvenNotSolvable; // NO until proven otherwise.
 @public  // so PuzzleProxy can get fast hard access to it.
  char                        puzzle[9][9];
}
- (void)setIntValue:(int)val row:(int)row column:(int)column;
// ** Actions (sent from menu bar to first responder, so I.B. doesn't need to know about them here)
- (void)toggleCreatorMode:(id)sender;
- (void)lock:(id)sender;
- (void)unlock:(id)sender;
- (BOOL)isProvenNotSolvable;
- (void)setIsProvenNotSolvable:(BOOL)solvable;
// - (void)solve:(id)sender;  // moved to PsuedokoSolve.h

// close and finalize any text editor edits, including their undogroup
// return YES if canContinue
- (BOOL)endEditing;
@end
/*
Permission is hereby granted, free of charge, to any person obtaining
a copy of these files and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
